﻿/* tslint:disable */
//----------------------
// <auto-generated>
//     Generated using the NSwag toolchain v11.20.1.0 (NJsonSchema v9.11.0.0 (Newtonsoft.Json v9.0.0.0)) (http://NSwag.org)
// </auto-generated>
//----------------------
// ReSharper disable InconsistentNaming

import { mergeMap as _observableMergeMap, catchError as _observableCatch } from 'rxjs/operators';
import { Observable, throwError as _observableThrow, of as _observableOf } from 'rxjs';
import { Injectable, Inject, Optional, InjectionToken } from '@angular/core';
import { HttpClient, HttpHeaders, HttpResponse, HttpResponseBase } from '@angular/common/http';

import * as moment from 'moment';

export const API_BASE_URL = new InjectionToken<string>('API_BASE_URL');

@Injectable()
export class OspiServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param obratovalnicaID (optional) 
     * @return Success
     */
    getNajaveByObratovalnicaID(obratovalnicaID: number | null | undefined): Observable<ListResultDtoOfDtoNajavaEdit> {
        let url_ = this.baseUrl + "/api/services/ospi?";
        if (obratovalnicaID !== undefined)
            url_ += "ObratovalnicaID=" + encodeURIComponent("" + obratovalnicaID) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "application/json"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetNajaveByObratovalnicaID(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetNajaveByObratovalnicaID(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfDtoNajavaEdit>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfDtoNajavaEdit>><any>_observableThrow(response_);
        }));
    }

    protected processGetNajaveByObratovalnicaID(response: HttpResponseBase): Observable<ListResultDtoOfDtoNajavaEdit> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 ? ListResultDtoOfDtoNajavaEdit.fromJS(resultData200) : new ListResultDtoOfDtoNajavaEdit();
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfDtoNajavaEdit>(<any>null);
    }

    /**
     * @param input (optional) 
     * @return Success
     */
    putNajaveByinput(input: DtoNajavaEdit | null | undefined): Observable<DtoNajavaEdit> {
        let url_ = this.baseUrl + "/api/services/ospi";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(input);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json", 
                "Accept": "application/json"
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processPutNajaveByinput(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processPutNajaveByinput(<any>response_);
                } catch (e) {
                    return <Observable<DtoNajavaEdit>><any>_observableThrow(e);
                }
            } else
                return <Observable<DtoNajavaEdit>><any>_observableThrow(response_);
        }));
    }

    protected processPutNajaveByinput(response: HttpResponseBase): Observable<DtoNajavaEdit> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 ? DtoNajavaEdit.fromJS(resultData200) : new DtoNajavaEdit();
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<DtoNajavaEdit>(<any>null);
    }
}

export class ListResultDtoOfDtoNajavaEdit implements IListResultDtoOfDtoNajavaEdit {
    items!: DtoNajavaEdit[] | undefined;

    constructor(data?: IListResultDtoOfDtoNajavaEdit) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (data["items"] && data["items"].constructor === Array) {
                this.items = [];
                for (let item of data["items"])
                    this.items.push(DtoNajavaEdit.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfDtoNajavaEdit {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfDtoNajavaEdit();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (this.items && this.items.constructor === Array) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfDtoNajavaEdit {
    items: DtoNajavaEdit[] | undefined;
}

export class DtoNajavaEdit implements IDtoNajavaEdit {
    id!: number | undefined;
    obratovalnicaID!: number | undefined;
    firma!: string | undefined;
    naslov!: string | undefined;
    poklicId!: number | undefined;
    poklicNaziv!: string | undefined;
    verificiranaUM!: number | undefined;
    razpisanaSolskaUM!: number | undefined;
    razpisanaVajeniskaUM!: number | undefined;
    eMail!: string | undefined;
    url!: string | undefined;
    opomba!: string | undefined;

    constructor(data?: IDtoNajavaEdit) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.obratovalnicaID = data["obratovalnicaID"];
            this.firma = data["firma"];
            this.naslov = data["naslov"];
            this.poklicId = data["poklicId"];
            this.poklicNaziv = data["poklicNaziv"];
            this.verificiranaUM = data["verificiranaUM"];
            this.razpisanaSolskaUM = data["razpisanaSolskaUM"];
            this.razpisanaVajeniskaUM = data["razpisanaVajeniskaUM"];
            this.eMail = data["eMail"];
            this.url = data["url"];
            this.opomba = data["opomba"];
        }
    }

    static fromJS(data: any): DtoNajavaEdit {
        data = typeof data === 'object' ? data : {};
        let result = new DtoNajavaEdit();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["obratovalnicaID"] = this.obratovalnicaID;
        data["firma"] = this.firma;
        data["naslov"] = this.naslov;
        data["poklicId"] = this.poklicId;
        data["poklicNaziv"] = this.poklicNaziv;
        data["verificiranaUM"] = this.verificiranaUM;
        data["razpisanaSolskaUM"] = this.razpisanaSolskaUM;
        data["razpisanaVajeniskaUM"] = this.razpisanaVajeniskaUM;
        data["eMail"] = this.eMail;
        data["url"] = this.url;
        data["opomba"] = this.opomba;
        return data; 
    }
}

export interface IDtoNajavaEdit {
    id: number | undefined;
    obratovalnicaID: number | undefined;
    firma: string | undefined;
    naslov: string | undefined;
    poklicId: number | undefined;
    poklicNaziv: string | undefined;
    verificiranaUM: number | undefined;
    razpisanaSolskaUM: number | undefined;
    razpisanaVajeniskaUM: number | undefined;
    eMail: string | undefined;
    url: string | undefined;
    opomba: string | undefined;
}

export class SwaggerException extends Error {
    message: string;
    status: number; 
    response: string; 
    headers: { [key: string]: any; };
    result: any; 

    constructor(message: string, status: number, response: string, headers: { [key: string]: any; }, result: any) {
        super();

        this.message = message;
        this.status = status;
        this.response = response;
        this.headers = headers;
        this.result = result;
    }

    protected isSwaggerException = true;

    static isSwaggerException(obj: any): obj is SwaggerException {
        return obj.isSwaggerException === true;
    }
}

function throwException(message: string, status: number, response: string, headers: { [key: string]: any; }, result?: any): Observable<any> {
    if(result !== null && result !== undefined)
        return _observableThrow(result);
    else
        return _observableThrow(new SwaggerException(message, status, response, headers, null));
}

function blobToText(blob: any): Observable<string> {
    return new Observable<string>((observer: any) => {
        if (!blob) {
            observer.next("");
            observer.complete();
        } else {
            let reader = new FileReader(); 
            reader.onload = function() { 
                observer.next(this.result);
                observer.complete();
            }
            reader.readAsText(blob); 
        }
    });
}